<?php
// Exclusion des catégories vides dans un menu
function exclure_cat_pages_menu_vides($menu_items, $menu, $args) {
	if(!is_admin()) {
		// Récupère l'ensemble des catégories non vides
		$categories = get_categories(array('taxonomy' => 'category'));
		$pages = get_pages();

		// On teste chaque item du menu pour récupérer tout ce qui ne correspond pas à une catégorie vide
		foreach($menu_items as $item) {
			// Si l'item de menu est une catégorie, on teste...
			if($item->post-type == "nav_menu_item" && $item->object == "category") {
				foreach($categories as $category) {
					if($category->cat_ID == $item->object_id) {
						$items_non_vides[] = $item;
						break;
					}
				}
			} elseif($item->post-type == "nav_menu_item" && $item->object == "page") { // Si l'item est une page, on teste...
				foreach($pages as $page) {
					if($page->ID == $item->object_id) {
						if(!empty($page->post_content)) {
							$items_non_vides[] = $item;
							break;
						}
					}
				}				
			} else { // Sinon, il s'agit d'un autre type à conserver (post-format, custom...)
				$items_non_vides[] = $item;
			}
		}
		
		// Retourne le menu avec les catégories non vides uniquement
		return $items_non_vides;
	} else {
		// Retourne le menu d'origine dans le backoffice
		return $menu_items;
	}
}
add_filter('wp_get_nav_menu_items', 'exclure_cat_pages_menu_vides', null, 3);
?>